## kmymoney 5.0.1

=== doc/CMakeLists.txt ===
kdoctools_create_handbook(index.docbook INSTALL_DESTINATION ${HTML_INSTALL_DIR}/en SUBDIR kmymoney)
kdoctools_create_manpage(man-kmymoney.1.docbook 1 INSTALL_DESTINATION ${MAN_INSTALL_DIR})

=== kmymoney/CMakeLists.txt ===
include(ECMAddAppIcon)

include_directories(${CMAKE_CURRENT_SOURCE_DIR}
                    ${CMAKE_CURRENT_BINARY_DIR}
                    ${CMAKE_CURRENT_BINARY_DIR}/dialogs/
                    ${CMAKE_CURRENT_SOURCE_DIR}/widgets/
                    ${CMAKE_CURRENT_BINARY_DIR}/widgets/
                    ${CMAKE_CURRENT_SOURCE_DIR}/mymoney/
                    ${CMAKE_CURRENT_SOURCE_DIR}/mymoney/storage/
                    ${CMAKE_CURRENT_SOURCE_DIR}/plugins/
                    ${CMAKE_CURRENT_BINARY_DIR}/plugins/
                    ${CMAKE_CURRENT_SOURCE_DIR}/views/
                    ${CMAKE_CURRENT_SOURCE_DIR}/dialogs/
                    ${CMAKE_CURRENT_SOURCE_DIR}/converter/
                    ${CMAKE_CURRENT_BINARY_DIR}/dialogs/settings/
                    ${CMAKE_CURRENT_BINARY_DIR}/mymoney/storage/
                    ${CMAKE_CURRENT_BINARY_DIR}/mymoney/
                    ${CMAKE_CURRENT_SOURCE_DIR}/reports/
                    ${CMAKE_CURRENT_SOURCE_DIR}/wizards/endingbalancedlg/
                    ${CMAKE_CURRENT_BINARY_DIR}/wizards/endingbalancedlg/
                    ${CMAKE_CURRENT_SOURCE_DIR}/wizards/newinvestmentwizard/
                    ${CMAKE_CURRENT_BINARY_DIR}/wizards/newinvestmentwizard/
                    ${CMAKE_CURRENT_SOURCE_DIR}/wizards/newloanwizard/
                    ${CMAKE_CURRENT_BINARY_DIR}/wizards/newloanwizard/
                    ${CMAKE_CURRENT_SOURCE_DIR}/wizards/wizardpages/
                    ${CMAKE_CURRENT_SOURCE_DIR}/models/
                    ${CMAKE_CURRENT_BINARY_DIR}/models/
                    ${CMAKE_CURRENT_SOURCE_DIR}/icons/
                    ${CMAKE_CURRENT_BINARY_DIR}/icons/
                    ${CMAKE_CURRENT_BINARY_DIR}/payeeidentifier/ibanandbic/widgets/ # TODO: this line should be moved to the target it belongs
                    ${CMAKE_CURRENT_BINARY_DIR}/payeeidentifier/ibanandbic/
                    ${CMAKE_CURRENT_BINARY_DIR}/payeeidentifier/nationalaccount/
                    ${KMyMoney_SOURCE_DIR}/libkgpgfile/ )

add_subdirectory( mymoney )
add_subdirectory( models  )
add_subdirectory( plugins )
add_subdirectory( reports )
add_subdirectory( widgets )
add_subdirectory( dialogs )
add_subdirectory( views )
add_subdirectory( converter )
add_subdirectory( wizards )
add_subdirectory( pics )
add_subdirectory( html )
add_subdirectory( templates )
add_subdirectory( misc )
add_subdirectory( payeeidentifier )
add_subdirectory( icons )
if(BUILD_TESTING)
  add_subdirectory( tests )
endif()

set( _HEADERS kmymoneyutils.h kmymoneyglobalsettings.h )

########### settings code (kmm_config) STATIC ###############
set( kmm_config_SRCS kmymoneyglobalsettings.cpp )
kconfig_add_kcfg_files( kmm_config_SRCS kmymoneysettings.kcfgc )
add_library(kmm_config STATIC ${kmm_config_SRCS})
target_link_libraries(kmm_config KF5::WidgetsAddons KF5::ConfigWidgets Qt5::Sql Alkimia::alkimia)

########### common code (kmymoney_common) STATIC ###############
# will be linked into kmymoney, kmymoneytest, and libkmymoney.so

set( kmymoney_common_SRCS kmymoneyutils.cpp kstartuplogo.cpp kcreditswindow.cpp )
add_library(kmymoney_common STATIC ${kmymoney_common_SRCS})

target_link_libraries(kmymoney_common
  PUBLIC
    Qt5::Core
    KF5::ConfigGui
    KF5::WidgetsAddons
    Alkimia::alkimia
    kmm_widgets
    kmm_mymoney
    kmm_utils_webconnect
    kmm_utils_platformtools
)

# must build kmymoney/transactionsortoption.h
# from transactionsortoption.ui first
add_dependencies(kmymoney_common generate_base_ui_srcs kmm_config)
add_dependencies(wizardpages widgets)
add_dependencies(dialogs widgets)

if(USE_MODELTEST)
  set( kmymoney_common_LIBS ${kmymoney_common_LIBS} ${QT_QTTEST_LIBRARY})
endif(USE_MODELTEST)

########### kmymoney executable ###############

set( kmymoney_SRCS
  main.cpp
  kmymoney.cpp
  pluginloader.cpp
)

qt5_add_dbus_adaptor(kmymoney_SRCS org.kde.kmymoney.xml kmymoney.h KMyMoneyApp)
qt5_add_resources(kmymoney_SRCS kmymoney.qrc)

# collect application icons
file(GLOB_RECURSE KMYMONEY_APP_ICONS "${CMAKE_CURRENT_SOURCE_DIR}/icons/kmymoney/apps/*.png")
# add icons to application sources, to have them bundled
ecm_add_app_icon(kmymoney_SRCS ICONS ${KMYMONEY_APP_ICONS})

add_executable( kmymoney ${kmymoney_SRCS} )
target_link_libraries(kmymoney
  views
  reports
  kmymoney_base
  kmymoney_common
  newuserwizard
  newaccountwizard
  newinvestmentwizard
  newloanwizard
  endingbalancedlg
  wizardpages
  dialogs
  widgets
  settings
  converter
  models
  kmm_config
  kmm_widgets
  kmm_storage
  kmm_mymoney
  kgpgfile
  interfaces
  kmm_plugin
  Qt5::Core
  Qt5::Sql
  KF5::Archive
  KF5::ConfigGui
  KF5::WidgetsAddons
  KF5::KIOCore
  KF5::CoreAddons
  KChart
  $<$<BOOL:${USE_MODELTEST}>:Qt5::Test>
  $<$<BOOL:${KF5Holidays_FOUND}>:KF5::Holidays>
)

# own plist magic for mac os
if(APPLE)
    # own plist template
    set_target_properties(kmymoney PROPERTIES MACOSX_BUNDLE_INFO_PLIST ${CMAKE_CURRENT_SOURCE_DIR}/MacOSXBundleInfo.plist.in)

    # the MacOSX bundle display name property (CFBundleDisplayName) is not currently supported by cmake,
    # so has to be set for all targets in this cmake file
    set(MACOSX_BUNDLE_DISPLAY_NAME KMyMoney)
    set_target_properties(kmymoney PROPERTIES MACOSX_BUNDLE_GUI_IDENTIFIER "org.kde.KMyMoney")
    set_target_properties(kmymoney PROPERTIES MACOSX_BUNDLE_BUNDLE_NAME "KMyMoney")
    set_target_properties(kmymoney PROPERTIES MACOSX_BUNDLE_DISPLAY_NAME "KMyMoney")
    set_target_properties(kmymoney PROPERTIES MACOSX_BUNDLE_INFO_STRING "KMyMoney - Personal Finances Manager")
    set_target_properties(kmymoney PROPERTIES MACOSX_BUNDLE_LONG_VERSION_STRING "KMyMoney ${KDE_APPLICATIONS_VERSION}")
    set_target_properties(kmymoney PROPERTIES MACOSX_BUNDLE_SHORT_VERSION_STRING "${KDE_APPLICATIONS_VERSION_MAJOR}.${KDE_APPLICATIONS_VERSION_MINOR}")
    set_target_properties(kmymoney PROPERTIES MACOSX_BUNDLE_BUNDLE_VERSION "${KDE_APPLICATIONS_VERSION}")
    set_target_properties(kmymoney PROPERTIES MACOSX_BUNDLE_COPYRIGHT "2000-2016 The KMyMoney Authors")
endif()

########### install files ###############

install(TARGETS kmymoney ${INSTALL_TARGETS_DEFAULT_ARGS})

install(FILES kmymoney.kcfg
  DESTINATION ${KCFG_INSTALL_DIR}
  )
install(FILES kmymoney.upd
  DESTINATION ${KCONF_UPDATE_INSTALL_DIR}
  )
install(FILES ${_HEADERS}
  DESTINATION ${INCLUDE_INSTALL_DIR}/kmymoney
  )
install(FILES org.kde.kmymoney.desktop
  DESTINATION ${XDG_APPS_INSTALL_DIR}
  )
install(FILES org.kde.kmymoney.appdata.xml
  DESTINATION ${KDE_INSTALL_METAINFODIR}
  )

install(FILES x-kmymoney.xml
  DESTINATION ${XDG_MIME_INSTALL_DIR})

install(FILES
   tips
   DESTINATION ${CMAKE_INSTALL_DATADIR}/kmymoney)

#UPDATE_XDG_MIMETYPES(${XDG_MIME_INSTALL_DIR})

=== kmymoney/converter/CMakeLists.txt ===
if(BUILD_TESTING)
  add_subdirectory( tests )
endif()

set (libconverter_a_SOURCES
  mymoneystatementreader.cpp
  mymoneytemplate.cpp
  webpricequote.cpp
  transactionmatchfinder.cpp
  existingtransactionmatchfinder.cpp
  scheduledtransactionmatchfinder.cpp
  ../widgets/kmymoneymoneyvalidator.cpp
)

add_library(converter STATIC ${libconverter_a_SOURCES})

# TODO: clean dependencies
target_link_libraries(converter PUBLIC KF5::Service KF5::XmlGui KF5::Completion KF5::TextWidgets KF5::WidgetsAddons KF5::ConfigCore KF5::I18n Qt5::Widgets Qt5::Gui Qt5::Sql Qt5::Xml Alkimia::alkimia KF5::KIOWidgets kmm_csvimportercore
PRIVATE
newaccountwizard)

# we rely on some dialogs to be generated
add_dependencies(converter dialogs)

########### install files ###############

install(FILES mymoneytemplate.h
  DESTINATION ${INCLUDE_INSTALL_DIR}/kmymoney COMPONENT Devel)

=== kmymoney/dialogs/CMakeLists.txt ===
add_subdirectory( settings )

########### next target ###############

set(libdialogs_a_SOURCES
  splitadjustdialog.cpp
  investactivities.cpp
  investtransactioneditor.cpp
  kaccountselectdlg.cpp
  kbackupdlg.cpp
  kbalancechartdlg.cpp
  kbalancewarning.cpp
  kcategoryreassigndlg.cpp
  kchooseimportexportdlg.cpp
  kconfirmmanualenterdlg.cpp
  kcurrencycalculator.cpp
  kcurrencyeditdlg.cpp
  kavailablecurrencydlg.cpp
  kcurrencyeditordlg.cpp
  keditscheduledlg.cpp
  kenterscheduledlg.cpp
  kequitypriceupdatedlg.cpp
  kequitypriceupdateconfdlg.cpp
  kfindtransactiondlg.cpp
  kgeneratesqldlg.cpp
  kgpgkeyselectiondlg.cpp
  kloadtemplatedlg.cpp
  kmergetransactionsdlg.cpp
  kmymoneyfileinfodlg.cpp
  kmymoneypricedlg.cpp
  kmymoneysplittable.cpp
  knewaccountdlg.cpp
  hierarchyfilterproxymodel.cpp
  knewbankdlg.cpp
  knewbudgetdlg.cpp
  knewequityentrydlg.cpp
  editpersonaldatadlg.cpp
  kpayeereassigndlg.cpp
  ktagreassigndlg.cpp
  kreportconfigurationfilterdlg.cpp
  kselectdatabasedlg.cpp
  kselecttransactionsdlg.cpp
  ksplittransactiondlg.cpp
  ktemplateexportdlg.cpp
  kupdatestockpricedlg.cpp
  transactioneditor.cpp
  stdtransactioneditor.cpp
  transactionmatcher.cpp
  konlinetransferform.cpp
)

set(dialogs_HEADERS
  splitadjustdialog.h
  investtransactioneditor.h kcurrencycalculator.h transactioneditor.h stdtransactioneditor.h
  )

set(dialogs_UI
  splitadjustdialog.ui
  kaccountselectdlg.ui kbackupdlg.ui
  kcategoryreassigndlg.ui kchooseimportexportdlg.ui
  kconfirmmanualenterdlg.ui
  kcurrencycalculator.ui kcurrencyeditdlg.ui kavailablecurrencydlg.ui kcurrencyeditordlg.ui
  keditscheduledlg.ui
  kenterscheduledlg.ui
  kequitypriceupdatedlg.ui kequitypriceupdateconfdlg.ui
  kfindtransactiondlg.ui kgeneratesqldlg.ui
  kgpgkeyselectiondlg.ui
  kloadtemplatedlg.ui
  kmymoneyfileinfodlg.ui kmymoneypricedlg.ui
  knewaccountdlg.ui knewbankdlg.ui knewbudgetdlg.ui
  knewequityentrydlg.ui editpersonaldatadlg.ui kpayeereassigndlg.ui
  ktagreassigndlg.ui
  kselectdatabasedlg.ui kselecttransactionsdlg.ui
  ksortoptiondlg.ui ksplitcorrectiondlg.ui ksplittransactiondlg.ui
  ktemplateexportdlg.ui
  kupdatestockpricedlg.ui
  konlinetransferform.ui
)

ki18n_wrap_ui(libdialogs_a_SOURCES ${dialogs_UI} )

add_library(dialogs STATIC ${libdialogs_a_SOURCES})

target_link_libraries(dialogs
  PUBLIC
    KChart
    KF5::ItemViews
    KF5::I18n
    KF5::TextWidgets
    KF5::Completion
    Qt5::Widgets
    Qt5::Sql
    Alkimia::alkimia
    kmm_mymoney
    onlinetask_interfaces
    kmm_widgets
    kmm_utils_platformtools
)

target_link_libraries(dialogs LINK_PUBLIC
  kmm_widgets
  kmm_mymoney
  onlinetask_interfaces
)


########### install files ###############

install(FILES  ${dialogs_HEADERS}
  DESTINATION ${INCLUDE_INSTALL_DIR}/kmymoney COMPONENT Devel)

=== kmymoney/icons/CMakeLists.txt ===
include(ECMInstallIcons)

add_definitions(-DKMYMONEY_ICON_DIR="${CMAKE_INSTALL_PREFIX}/${DATA_INSTALL_DIR}/kmymoney/icons")

file(GLOB_RECURSE KMYMONEY_HICOLOR_ICONS "hicolor/*")
ecm_install_icons(
  ICONS ${KMYMONEY_HICOLOR_ICONS}
  DESTINATION ${DATA_INSTALL_DIR}/kmymoney/icons
  THEME "hicolor"
)

file(GLOB_RECURSE KMYMONEY_OXYGEN_ICONS "oxygen/*")
ecm_install_icons(
  ICONS ${KMYMONEY_OXYGEN_ICONS}
  DESTINATION ${DATA_INSTALL_DIR}/kmymoney/icons
  THEME "oxygen"
)

file(GLOB_RECURSE KMYMONEY_TANGO_ICONS "Tango/*")
ecm_install_icons(
  ICONS ${KMYMONEY_TANGO_ICONS}
  DESTINATION ${DATA_INSTALL_DIR}/kmymoney/icons
  THEME "Tango"
)

file(GLOB_RECURSE KMYMONEY_ICONS "kmymoney/*.png")
ecm_install_icons(
  ICONS ${KMYMONEY_ICONS}
  DESTINATION ${ICON_INSTALL_DIR}
)

set (icons_SOURCES
  icons.cpp
)

add_library(kmm_icons SHARED ${icons_SOURCES})
generate_export_header(kmm_icons)
target_link_libraries(kmm_icons PRIVATE Qt5::Core Qt5::Gui)

set_target_properties(kmm_icons PROPERTIES
  VERSION ${PROJECT_VERSION} SOVERSION ${PROJECT_VERSION_MAJOR}
)

install(TARGETS kmm_icons
  ${INSTALL_TARGETS_DEFAULT_ARGS} )

=== kmymoney/models/CMakeLists.txt ===
set(libmodels_a_SOURCES
    costcentermodel.cpp
    payeesmodel.cpp
    accountsmodel.cpp
    accountsproxymodel.cpp
    onlinejobmodel.cpp
    onlinebankingaccountsfilterproxymodel.cpp
    ../mymoney/onlinejobmessage.cpp
    ../plugins/onlinetasks/interfaces/tasks/credittransfer.cpp
    models.cpp
    payeeidentifiercontainermodel.cpp
    onlinejobmessagesmodel.cpp
    equitiesmodel.cpp
    securitiesmodel.cpp
)

if(ENABLE_UNFINISHEDFEATURES)
  list(APPEND libmodels_a_SOURCES
    ledgermodel.cpp
    ledgeritem.cpp
    ledgerproxymodel.cpp
    ledgerschedule.cpp
    ledgersplit.cpp
    ledgertransaction.cpp
    splitmodel.cpp
  )
endif()

if (USE_MODELTEST)
  list(APPEND libmodels_a_SOURCES modeltest.cpp)
endif()

add_library(models STATIC ${libmodels_a_SOURCES})

target_link_libraries(models PUBLIC
    kmm_mymoney
    kmymoney_common
    KF5::ItemModels
)

if (USE_MODELTEST)
  target_compile_definitions(models PRIVATE -DKMM_MODELTEST)
  target_link_libraries(models PRIVATE Qt5::Test)
endif()

add_dependencies(models kmm_config)

=== kmymoney/pics/CMakeLists.txt ===
add_subdirectory( l10n )
install(FILES  startlogo.png  titlelabel_background.png
  DESTINATION ${DATA_INSTALL_DIR}/kmymoney/pics/
)

=== kmymoney/reports/CMakeLists.txt ===
if(BUILD_TESTING)
  add_subdirectory(tests)
endif()

set (libreports_a_SOURCES
  kreportchartview.cpp
  reportaccount.cpp
  listtable.cpp
  objectinfotable.cpp
  pivotgrid.cpp
  pivottable.cpp
  querytable.cpp
  reporttable.cpp
  kbalanceaxis.cpp
)

add_library(reports STATIC ${libreports_a_SOURCES})
target_link_libraries(reports
  PUBLIC
    KChart
    Alkimia::alkimia
    Qt5::Sql
    Qt5::PrintSupport
    kmymoney_common
)

add_dependencies(reports kmm_config)

=== kmymoney/tests/CMakeLists.txt ===
include(ECMAddTests)

file(GLOB tests_sources "*-test.cpp")
ecm_add_tests(${tests_sources}
  NAME_PREFIX
    "kmymoney-"
  LINK_LIBRARIES
    Qt5::Core
    Qt5::Test
    kmymoney_common
)

=== kmymoney/widgets/CMakeLists.txt ===

########### create links ###############
set(kmymoney_STAT_HEADERS
  kaccounttemplateselector.h kbudgetvalues.h kguiutils.h
  kmymoneyaccountcombo.h kmymoneyaccountcompletion.h
  kmymoneyaccountselector.h
  kmymoneycategory.h
  kmymoneycombo.h kmymoneymvccombo.h kmymoneycompletion.h
  kmymoneycurrencyselector.h  kmymoneydateinput.h kmymoneyedit.h
  kmymoneylineedit.h kmymoneyselector.h
  kmymoneytitlelabel.h register.h registeritem.h groupmarker.h fancydategroupmarker.h
  scheduledtransaction.h selectedtransaction.h selectedtransactions.h stdtransactiondownloaded.h
  stdtransactionmatched.h transactioneditorcontainer.h
  transactionform.h transaction.h investtransaction.h stdtransaction.h
  transactionsortoption.h reporttabimpl.h reportcontrolimpl.h
  kmymoneyvalidationfeedback.h
  onlinejobmessagesview.h
  kmymoneydateedit.h
  amountedit.h amountvalidator.h creditdebithelper.h
  )

########### Shared widget library ###########
set(kmm_widgets_sources
  widgets_config.cpp
  kmymoneydateinput.cpp
  kmymoneyvalidationfeedback.cpp
  styleditemdelegateforwarder.cpp
  kmymoneyedit.cpp
  kmymoneylineedit.cpp
  kmymoneytextedit.cpp
  kmymoneytextedithighlighter.cpp
  kmymoneymvccombo.cpp
  kmymoneygeneralcombo.cpp
  kmymoneyactivitycombo.cpp
  kmymoneycashflowcombo.cpp
  kmymoneyfrequencycombo.cpp
  kmymoneyoccurrencecombo.cpp
  kmymoneyoccurrenceperiodcombo.cpp
  kmymoneypayeecombo.cpp
  kmymoneyperiodcombo.cpp
  kmymoneyreconcilecombo.cpp
  kmymoneytagcombo.cpp
  ktagcontainer.cpp
  ktaglabel.cpp
  kmymoneyselector.cpp
  kmymoneycalculator.cpp
  ktreewidgetfilterlinewidget.cpp
  kguiutils.cpp
  onlinejobmessagesview.cpp
  kmymoneydateedit.cpp
  kmymoneymoneyvalidator.cpp
  amountedit.cpp
  amountvalidator.cpp
  creditdebithelper.cpp
  )

ki18n_wrap_ui(kmm_widgets_sources
  kmymoneyvalidationfeedback.ui
  onlinejobmessagesview.ui
)

add_library(kmm_widgets SHARED ${kmm_widgets_sources})
target_link_libraries(kmm_widgets PUBLIC
  KF5::TextWidgets
  KF5::KIOWidgets
  KF5::Completion
  KF5::Notifications
  KF5::ItemViews
  KF5::I18n
  Qt5::Gui
  Qt5::Sql
  Qt5::Core
  Alkimia::alkimia
  kmm_config
  kmm_mymoney
)

set_target_properties(kmm_widgets PROPERTIES
  VERSION ${PROJECT_VERSION} SOVERSION ${PROJECT_VERSION_MAJOR}
  COMPILE_FLAGS "-DKMM_BUILD_WIDGETS_LIB"
)

generate_export_header(kmm_widgets)

install(TARGETS kmm_widgets ${INSTALL_TARGETS_DEFAULT_ARGS} )

########### Basic Widget Library (kmymoney_base) STATIC #################

# Common sources for libkmymoney.so and libwidgets.a that do not
# contain the KMM_DESIGNER flag
set(_uncritial_common_sources
  fixedcolumntreeview.cpp
  kbudgetvalues.cpp
  kmymoneyaccountcombo.cpp
  kmymoneyaccountselector.cpp
  kmymoneyaccounttreeview.cpp
  accountsviewproxymodel.cpp
  budgetviewproxymodel.cpp
  kmymoneycombo.cpp
  kmymoneycompletion.cpp
  kmymoneytitlelabel.cpp
  kmymoneydateedit.cpp
  kpricetreeitem.cpp
  registeritem.cpp
  registerfilter.cpp
  scheduledtransaction.cpp
  selectedtransaction.cpp
  selectedtransactions.cpp
  stdtransactiondownloaded.cpp
  stdtransactionmatched.cpp
  transactionform.cpp
  tabbar.cpp
  transactionformitemdelegate.cpp
  transactionsortoption.cpp
  )

# sources that contain the KMM_DESIGNER flag
set (_critial_common_sources
  kaccounttemplateselector.cpp
  kmymoneycurrencyselector.cpp
  kmymoneyaccountcompletion.cpp
  kmymoneycategory.cpp
  groupmarker.cpp
  groupmarkers.cpp
  fancydategroupmarker.cpp
  fancydategroupmarkers.cpp
  register.cpp
  itemptrvector.cpp
  qwidgetcontainer.cpp
  registeritemdelegate.cpp
  transaction.cpp
  stdtransaction.cpp
  investtransaction.cpp
  transactioneditorcontainer.cpp
  )


set (kmymoney_base_UI
  kbudgetvalues.ui transactionsortoption.ui kaccounttemplateselector.ui
  )

ki18n_wrap_ui(kmymoney_base_ui_srcs ${kmymoney_base_UI})
set(_uncritial_common_sources ${_uncritial_common_sources}
  ${kmymoney_base_ui_srcs})

# in order to use add_dependencies, we need to add this custom target
# for all generated header files.
# (see http://www.vtk.org/Wiki/CMake_FAQ#How_can_I_add_a_dependency_to_a_source_file_which_is_generated_in_a_subdirectory.3F )
add_custom_target(generate_base_ui_srcs DEPENDS
  ${kmymoney_base_ui_srcs})

# We can compile the uncritical sources without KMM_DESIGNER flags
add_library(kmymoney_base STATIC ${_uncritial_common_sources})
# TODO: fix dependencies
target_link_libraries(kmymoney_base KF5::XmlGui KF5::TextWidgets KF5::IconThemes KF5::I18n KF5::ConfigWidgets KF5::ConfigCore KF5::Completion KF5::Service Qt5::Gui Qt5::Widgets Qt5::Sql Qt5::Xml Alkimia::alkimia)

add_dependencies(kmymoney_base kmm_config)

########### QtDesigner Widget Library (kmymoneywidgets) #################
# we never link against this library,
# but it is needed for uic and QtDesigner
if( USE_QT_DESIGNER )
  set(kmymoneywidgets_PART_SRCS
      ${CMAKE_CURRENT_BINARY_DIR}/kmymoneywidgets.cpp)

  kde4_add_widget_files(kmymoneywidgets_PART_SRCS kmymoney.widgets)

  set(kmymoneywidgets_PART_SRCS
    ${_critial_common_sources}
    ${kmymoneywidgets_PART_SRCS})

  add_library(kmymoneywidgets MODULE ${kmymoneywidgets_PART_SRCS})

  include_directories( ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_BINARY_DIR} )

  # The option -DKMM_DESIGNER will leave away any code that breaks uic.
  set_target_properties(kmymoneywidgets PROPERTIES
    COMPILE_FLAGS "-DKMM_DESIGNER")

  # The qt-designer widget library shouldn't need to link against the
  # dialogs and converter libraries.  If a widget references something
  # from one of these libraries it is most likely due to code that needs
  # to be excluded with a KMM_DESIGNER ifndef.
  target_link_libraries(kmymoneywidgets kmymoney_base kmm_mymoney kmymoney_common kmm_config models)

  install(TARGETS kmymoneywidgets DESTINATION ${QT_PLUGINS_DIR}/designer )
endif( USE_QT_DESIGNER )

########### Widget Library (widgets) STATIC #################

set(libwidgets_a_SOURCES
  ${_critial_common_sources}
  kmymoneybriefschedule.cpp
  registersearchline.cpp
  transactioneditorcontainer.cpp
  reporttabimpl.cpp
  reportcontrolimpl.cpp
  daterangedlg.cpp
  )

set(libwidgets_a_UI
  kmymoneybriefschedule.ui reportcontrol.ui
  reporttabgeneral.ui
  reporttabrowcolquery.ui reporttabrowcolpivot.ui
  reporttabrange.ui reporttabchart.ui
  reporttabcapitalgain.ui reporttabperformance.ui
  daterangedlg.ui
  )

# using uic on the above UI files DEPENDS on libkmymoney.so. If uic
# does not find libkmymoney.so, gcc will fail compiling
# kmymoneyreportconfigtab2decl.cpp and throw errors like "invalid use
# of undefined type `struct KMyMoneyGeneralCombo'"


ki18n_wrap_ui(widgets_ui_srcs ${libwidgets_a_UI})
add_custom_target(generate_widgets_ui_srcs DEPENDS ${widgets_ui_srcs})

add_library(widgets STATIC
  ${libwidgets_a_SOURCES}
  ${widgets_ui_srcs}
  )
target_link_libraries(widgets KF5::XmlGui kmymoney_base)

add_dependencies(widgets kmm_config)

########### install files ###############

install(FILES ${kmymoney_STAT_HEADERS} ${CMAKE_CURRENT_BINARY_DIR}/kmm_widgets_export.h
  DESTINATION ${INCLUDE_INSTALL_DIR}/kmymoney COMPONENT Devel)

=== kmymoney/wizards/CMakeLists.txt ===
project(Wizards)

include_directories( ${CMAKE_CURRENT_BINARY_DIR}/wizardpages)

add_subdirectory( wizardpages )
add_subdirectory( newuserwizard )
add_subdirectory( newaccountwizard )
add_subdirectory( newinvestmentwizard )
add_subdirectory( newloanwizard )
add_subdirectory( endingbalancedlg )

set(kmymoneywizard_sources
  kmymoneywizard.cpp
  kmymoneywizardpage.cpp
  )

add_library(kmymoneywizard STATIC ${kmymoneywizard_sources})

target_link_libraries(kmymoneywizard KF5::XmlGui KF5::TextWidgets)

=== kmymoney/converter/tests/CMakeLists.txt ===
include(ECMAddTests)

file(GLOB tests_sources "*-test.cpp")
ecm_add_tests(${tests_sources}
  LINK_LIBRARIES
    Qt5::Core
    Qt5::Test
    reports_testcommon
    converter
)

=== debian/changelog ===
kmymoney (5.0.1-2) experimental; urgency=medium

  * Team upload.
  * Switch the libical2-dev build dependency back to libical-dev, as the KF5
    kcalcore switched to libical3.

 -- Pino Toscano <pino@debian.org>  Sun, 01 Apr 2018 09:21:06 +0200

kmymoney (5.0.1-1) experimental; urgency=medium

  * Team upload.
  * New upstream release:
    - installs the action icons in a local path again (Closes: #891007)
  * Update the build dependencies:
    - remove kross-dev, no more used
    - add python-dev, and python-weboob, used by the new version of the weboob
      plugin
  * Update the patches:
    - upstream_cmake-set-SONAME-also-for-kmm_icons-and-kmm_csvimpor.patch:
      drop, backported from upstream
  * Update install files.
  * Switch the krosspython recommend to python-weboob, as it is what the weboob
    plugin uses.

 -- Pino Toscano <pino@debian.org>  Tue, 20 Mar 2018 07:01:31 +0100

kmymoney (5.0.0-1) experimental; urgency=medium

  * Team upload.
  * New upstream release:
    - switches from Qt4 to Frameworks (Closes: #874961)
    - integrates with KDEPIM 5.x (Closes: #823215)
    - there is no more --lang command line option (Closes: #598634, #598636)
  * Update the patches:
    - qreal.diff: drop, obsolete
  * Update the build dependencies following the port to Frameworks:
    - remove kdelibs5-dev, kdepimlibs5-dev, libgwengui-qt4-dev, and
      libalkimia-dev
    - add extra-cmake-modules, qtbase5-dev, qtdeclarative5-dev, libqt5svg5-dev,
      libkf5activities-dev, libkf5akonadi-dev, libkf5archive-dev,
      libkf5completion-dev, libkf5config-dev, libkf5configwidgets-dev,
      libkf5contacts-dev, libkf5coreaddons-dev, libkf5doctools-dev,
      libkf5holidays-dev, libkf5i18n-dev, libkf5iconthemes-dev,
      libkf5identitymanagement-dev, libkf5itemmodels-dev, libkf5itemviews-dev,
      libkchart-dev, libkf5kcmutils-dev, libkf5kio-dev, kross-dev,
      libkf5notifications-dev, libkf5service-dev, libkf5textwidgets-dev,
      libkf5wallet-dev, libkf5webkit-dev, libkf5xmlgui-dev,
      libgwengui-qt5-dev, and libalkimia5-dev
  * Update the rest of the build dependencies:
    - switch libgpgme11-dev to libgpgmepp-dev
    - add libgpg-error-dev, and libgpgme-dev to workaround missing dependencies
      in libgpgmepp-dev
    - remove libboost-graph-dev, and shared-mime-info, as they are not used
  * Use the right dh addon:
    - switch from kde to kf5 dh addon
    - bump the pkg-kde-tools build dependency to >= 0.15.16
  * Switch the -DKDE4_BUILD_TESTS=OFF cmake parameter to -DBUILD_TESTING=OFF,
    as it is what ECM provides.
  * Stop moving manually the appdata file, as it is installed in the right
    place now.
  * Update install files.
  * Update lintian overrides.
  * Stop removing man-*.docbook files, since they are not installed anymore.
  * Remove get-orig-source target from rules, as it is obsolete.
  * Recommend krosspython for the weboob plugin. (Closes: #865885)
  * Remove old stuff from watch file.
  * Backport upstream commit 16eb1fea93db913ec0a2cd8d825366473733a290 to set
    the SONAME for the kmm_icons, and kmm_csvimportercore libraries; patch
    upstream_cmake-set-SONAME-also-for-kmm_icons-and-kmm_csvimpor.patch.
  * Bump the debhelper compatibility to 11:
    - bump compat to 11
    - bump the debhelper build dependency to 11
    - remove --parallel to dh
  * Add the kcalc suggest, as kmymoney can invoke it as additional tool.

 -- Pino Toscano <pino@debian.org>  Fri, 09 Feb 2018 22:13:32 +0100

=== debian/control ===
Source: kmymoney
Section: kde
Priority: optional
Maintainer: Debian KDE Extras Team <pkg-kde-extras@lists.alioth.debian.org>
Uploaders: Mark Purcell <msp@debian.org>
Build-Depends: debhelper (>= 11), cmake, pkg-kde-tools (>= 0.15.16),
 extra-cmake-modules,
 qtbase5-dev,
 qtdeclarative5-dev,
 libqt5svg5-dev,
 libkf5activities-dev,
 libkf5akonadi-dev,
 libkf5archive-dev,
 libkf5completion-dev,
 libkf5config-dev,
 libkf5configwidgets-dev,
 libkf5contacts-dev,
 libkf5coreaddons-dev,
 libkf5doctools-dev,
 libkf5holidays-dev,
 libkf5i18n-dev,
 libkf5iconthemes-dev,
 libkf5identitymanagement-dev,
 libkf5itemmodels-dev,
 libkf5itemviews-dev,
 libkchart-dev,
 libkf5kcmutils-dev,
 libkf5kio-dev,
 libkf5notifications-dev,
 libkf5service-dev,
 libkf5textwidgets-dev,
 libkf5wallet-dev,
 libkf5webkit-dev,
 libkf5xmlgui-dev,
 libaqbanking-dev (>= 5.6.1beta),
 libgwenhywfar-core-dev, libgwengui-qt5-dev,
 libgpgmepp-dev, libgpg-error-dev, libgpgme-dev,
 libalkimia5-dev (>= 7.0),
 libical-dev, libofx-dev, libgmp-dev,
 pkg-config,
 python-dev,
 python-weboob,
Standards-Version: 4.1.3
Homepage: https://kmymoney.org/
Vcs-Browser: https://anonscm.debian.org/viewvc/pkg-kde/kde-extras/kmymoney2/
Vcs-Svn: svn://anonscm.debian.org/pkg-kde/kde-extras/kmymoney2/trunk

Package: kmymoney
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ${aqbanking:Depends}, kmymoney-common (= ${source:Version})
Recommends: gnupg-agent, pinentry-qt | pinentry-x11
Suggests: kcalc
Description: personal finance manager for KDE
 KMyMoney is the Personal Finance Manager for KDE. It operates similar to
 MS-Money and Quicken, supports different account types, categorisation of
 expenses, QIF import/export, multiple currencies and initial online banking
 support.

Package: kmymoney-common
Architecture: all
Depends: ${misc:Depends},
 ${perl:Depends},
Recommends: kmymoney,
 python-weboob,
 libfinance-quote-perl,
Description: KMyMoney architecture independent files
 KMyMoney is the Personal Finance Manager for KDE. It operates similar to
 MS-Money and Quicken, supports different account types, categorisation of
 expenses, QIF import/export, multiple currencies and initial online banking
 support.
 .
 This package contains architecture independent files needed for KMyMoney to
 run properly. It also provides KMyMoney documentation. Therefore, unless you
 have 'kmymoney' package installed, you will hardly find this package useful.

=== debian/rules ===
#!/usr/bin/make -f
%:
	dh $@ --list-missing --with kf5,aqbanking

override_dh_auto_configure:
	dh_auto_configure -Skf5 -- -DCMAKE_SKIP_RPATH=ON -DBUILD_TESTING=OFF

override_dh_auto_install:
	dh_auto_install
	# remove development stuff
	rm -rf debian/tmp/usr/include/
	find debian/tmp -name '*.so' -type l -delete

override_dh_strip:
	dh_strip --dbgsym-migration='kmymoney-dbg (<< 4.8.0-1~)'

.PHONY: override_dh_auto_test

=== debian/watch ===
version=4
https://download.kde.org/stable/kmymoney/([\d\.]+)/src/kmymoney-([\d\.]+)\.tar\.xz
